from enum import Enum
import click
import subprocess
# from .shazam import rename

from click.exceptions import ClickException


@click.group()
def cli():
    pass


class Stream(str, Enum):
    KEXP = "kexp"
    KUGS = "kugs"
    CLIS = "clis"


@cli.command("stream")
@click.option(
    "-s", "--stream", "stream", type=click.Choice(Stream), default=Stream.KEXP
)
def play_stream(stream):
    """Play the KEXP stream using mpv."""
    match stream:
        case Stream.KEXP:
            url = "https://kexp-mp3-128.streamguys1.com/kexp128.mp3"
        case Stream.KUGS:
            url = "https://peridot.streamguys1.com:7175/kugs-mp3""
        case Stream.CLIS:
            url = "https://stream2.statsradio.com:8012/stream?=&&___cb=759135934160766"
        case _:
            raise ClickException(f"unrecognized stream: {stream}")
    subprocess.run(["mpv", url])

@cli.command("random")
def play_random():
  """todo."""
    raise NotImplementedError("todo")
    # fd -t file -e mp3 -p -a "fall|winter|spring|summer" $HOME/Music/ | mpv --playlist=- --shuffle --no-video

@cli.command("save")
@click.option( "-u", "--url", "url", required=True)
def save_song(url):
  """todo."""
    raise NotImplementedError("todo")

    # FILENAME=$(yt-dlp {{url}} -x --audio-format mp3 | tee /dev/tty | grep 'ExtractAudio' | cut -d ' ' -f 3-)
    # $HOME/.local/lib/shazam/bin/shazam.py rename --song "$FILENAME"


if __name__ == "__main__":
    cli()
